hdu 2531 Catch him (bfs)

Catch him

Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 664    Accepted Submission(s): 307

Problem Description

在美式足球中,四分卫负责指挥整只球队的进攻战术和跑位,以及给接球员传球的任务。四分卫是一只球队进攻组最重要的球员,而且一般身体都相对比较弱小,所以通常球队会安排5-7名大汉来保护他,其中站在四分卫前方、排成一线的5名球员称为进攻锋线,他们通常都是135公斤左右的壮汉。

对防守方来说,攻击对手的四分卫当然是最直接的限制对手进攻的方法。如果效果好,就可以在对方四分卫传球之前将其按翻在地,称之为擒杀。擒杀是最好的鼓舞防守队士气的方法,因为对方连传球的机会都没有,进攻就结束了,还必须倒退一些距离开球。凶狠的擒杀甚至能够将对方的四分卫弄伤,从而迫使对方更换这个进攻核心。
在本题中,输入给出准备擒杀四分卫的防守球员的位置、对方每个进攻锋线球员的位置以及对方四分卫的位置,你的任务是求出这名准备擒杀的防守球员至少要移动多少步,才能够擒杀对方四分卫。
假设对方进攻锋线和四分卫在这个过程中都不会移动。只有1名防守球员,防守球员只要碰到对方四分卫就算擒杀。
所有的球员都是一块连续的、不中空的2维区域。防守球员不可以从进攻锋线的身体上穿过,也不可以从界外穿过(只能走空地)。
防守队员不可以转动身体,只能平移。防守队员的身体所有部分向同一个方向(上、下、左、右)移动1格的过程叫做1步。

Input

输入包含多组数据。每组数据第一行都是两个整数H,W(0<H,W<=100),表示整个区域的高度和宽度,H=W=0表示输入结束。接下来有H行,每行W个字符。每个字符如果是’.’,表示这里是空地,如果是’O’,表示是进攻锋线队员的身体,如果是’D’,表示是准备擒杀的防守球员的身体,如果是’Q’,表示是四分卫的身体。
输入保证符合上面的条件。防守球员的身体总共不超过20格。

Output

对每组数据,输出包含擒杀所需最少步数的一行。如果不能擒杀,输出带’Impossible’的一行。

Sample Input

6 6
.Q....
QQ..OO
.OO..O
...O.O
OO.O..
....DD
7 7
.Q.....
QQ.OOO.
...O...
O......
OO..OO.
.O.....
.....DD
0 0

Sample Output

Impossible
9

这题最开始昨天晚上看到直接懵了...

人的身体有多部分== 还不规则..怎么搞...

然后昨天睡觉的时候灵光一现(大雾

今天起来搞搞搞...

竟然1A....爽坏了

其实很简单.

就是只考虑一个点.

其他点存与最初这个点的相对位移.

然后只做这第一个点的bfs

只不过判断条件的时候要判断所有点的

以及是否摸(?)到四分卫的时候也要判断多个点的就好了.

  1 /*************************************************************************
  2     > File Name: code/hdu/2531.cpp
  3     > Author: 111qqz
  4     > Email: [email protected]
  5     > Created Time: 2015年10月11日 星期日 23时14分43秒
  6  ************************************************************************/
  7
  8 #include<iostream>
  9 #include<iomanip>
 10 #include<cstdio>
 11 #include<algorithm>
 12 #include<cmath>
 13 #include<cstring>
 14 #include<string>
 15 #include<map>
 16 #include<set>
 17 #include<queue>
 18 #include<vector>
 19 #include<stack>
 20 #include<cctype>
 21
 22 #define yn hez111qqz
 23 #define j1 cute111qqz
 24 #define ms(a,x) memset(a,x,sizeof(a))
 25 using namespace std;
 26 const int dx4[4]={1,0,0,-1};
 27 const int dy4[4]={0,-1,1,0};
 28 typedef long long LL;
 29 typedef double DB;
 30 const int inf = 0x3f3f3f3f;
 31 const int N=1E2+5;
 32 int w,h;
 33 char maze[N][N];
 34 bool v[N][N];
 35 int cnt ;
 36 int fx[30];
 37 int fy[30];
 38 struct node
 39 {
 40     int x,y;
 41     int d;
 42     bool ok()
 43     {
 44     if (x<0||y<0||x>=w||y>=h) return false;
 45     if (maze[x][y]==‘O‘) return false;
 46     if (v[x][y]) return false;
 47
 48     for ( int i =2 ; i <= cnt ; i++)
 49     {
 50         int xx = x + fx[i];
 51         int yy = y + fy[i];
 52         if (xx<0||yy<0||xx>=w||yy>=h) return false;
 53         if (maze[xx][yy]==‘O‘) return false;
 54     }
 55     return true;
 56     }
 57
 58     bool get()
 59     {
 60     if (maze[x][y]==‘Q‘) return true;
 61     for ( int i = 2 ; i <= cnt ; i++)
 62     {
 63         int xx = x + fx[i];
 64         int yy = y + fy[i];
 65         if (maze[xx][yy]==‘Q‘)
 66         {
 67         return true;
 68         }
 69     }
 70     return false;
 71     }
 72 }s;
 73
 74 bool bfs()
 75 {
 76
 77     queue<node>q;
 78     q.push(s);
 79
 80     while (!q.empty())
 81     {
 82     node pre = q.front();q.pop();
 83
 84 //    printf("x: %d  y: %d d: %d \n",pre.x,pre.y,pre.d);
 85
 86     if (pre.get())
 87     {
 88         printf("%d\n",pre.d);
 89         return true;
 90     }
 91
 92     for ( int i = 0 ; i < 4 ; i++)
 93     {
 94         node next;
 95         next.x = pre.x + dx4[i];
 96         next.y = pre.y + dy4[i];
 97         next.d = pre.d + 1;
 98         if (next.ok())
 99         {
100         v[next.x][next.y] = true;
101         q.push(next);
102         }
103     }
104     }
105     return false;
106
107 }
108 int main()
109 {
110   #ifndef  ONLINE_JUDGE
111    freopen("in.txt","r",stdin);
112   #endif
113
114    while (scanf("%d %d",&w,&h)!=EOF&&w&&h)
115    {
116        ms(v,false);
117        cnt = 0 ;
118        for ( int i = 0 ; i < w ; i++) scanf("%s",maze[i]);
119
120        for ( int i = 0 ; i < w ; i++)
121        for ( int j = 0 ; j < h ; j++)
122        {
123            if (maze[i][j]==‘D‘)
124            {
125            cnt++;
126            if (cnt==1)
127            {
128                fx[cnt] =  i;
129                fy[cnt] =  j;
130                s.x = i;
131                s.y = j;
132                s.d = 0 ;
133                v[i][j] = true;
134            }
135            else
136             {
137             fx[cnt] = i - fx[1]; //相对位移.
138             fy[cnt] = j - fy[1];
139             }
140            }
141        }
142
143        if (!bfs())
144     {
145         puts("Impossible");
146     }
147    }
148
149
150
151  #ifndef ONLINE_JUDGE
152   fclose(stdin);
153   #endif
154     return 0;
155 }

时间: 2024-11-11 05:08:31

hdu 2531 Catch him (bfs)的相关文章

[ACM] hdu 2717 Catch That Cow (BFS)

Catch That Cow Problem Description Farmer John has been informed of the location of a fugitive cow and wants to catch her immediately. He starts at a point N (0 ≤ N ≤ 100,000) on a number line and the cow is at a point K (0 ≤ K ≤ 100,000) on the same

hdu 1429 状压bfs

#include <iostream> #include <cstring> #include <string> #include <cstdio> #include <cmath> #include <algorithm> #include <vector> #include <queue> #include <map> #define inf 0x3f3f3f3f #define ll __in

HDU 1242 Rescue(优先队列+bfs)

题目地址:HDU 1242 这个题相比于普通的bfs有个特殊的地方,经过士兵时会额外消耗时间,也就是说此时最先搜到的时候不一定是用时最短的了.需要全部搜一遍才可以.这时候优先队列的好处就显现出来了.利用优先队列,可以让队列中的元素按时间排序,让先出来的总是时间短的,这样的话,最先搜到的一定是时间短的,就不用全部搜一遍了.PS:我是为了学优先队列做的这题..不是为了这题而现学的优先队列.. 代码如下: #include <iostream> #include <stdio.h> #i

POJ 2243 || HDU 1372:Knight Moves(BFS)

Knight Moves Time Limit: 1000MS Memory Limit: 65536K Total Submissions: 11223 Accepted: 6331 Description A friend of you is doing research on the Traveling Knight Problem (TKP) where you are to find the shortest closed tour of knight moves that visit

hdu 4400 离散化+二分+BFS(暴搜剪枝还超时的时候可以借鉴一下)

Mines Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 1110    Accepted Submission(s): 280 Problem Description Terrorists put some mines in a crowded square recently. The police evacuate all peo

HDU 4856 Tunnels(BFS+状压DP)

HDU 4856 Tunnels 题目链接 题意:给定一些管道,然后管道之间走是不用时间的,陆地上有障碍,陆地上走一步花费时间1,求遍历所有管道需要的最短时间,每个管道只能走一次 思路:先BFS预处理出两两管道的距离,然后状态压缩DP求解,dp[s][i]表示状态s,停在管道i时候的最小花费 代码: #include <cstdio> #include <cstring> #include <queue> #include <algorithm> using

HDU 1072 Nightmare (BFS)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1072 题目大意: 走迷宫,初始剩余时间为6min,每步1min:到reset区是若剩余时间大于0,则可以重置.到终点3区,若时间大于0,则成功逃脱.(可以走回路) 0:wall 1:可以走 2:起点 3:终点 4:剩余时间重置为6 源代码: #include<iostream> #include<cstring> #include<cstdio> #include<q

hdu 1242:Rescue(BFS广搜 + 优先队列)

Rescue Time Limit : 2000/1000ms (Java/Other)   Memory Limit : 65536/32768K (Java/Other) Total Submission(s) : 14   Accepted Submission(s) : 7 Font: Times New Roman | Verdana | Georgia Font Size: ← → Problem Description Angel was caught by the MOLIGPY

HDU 1242 &amp;&amp; ZOJ 1649( BFS (队列 || 优先队列)).

~~~~ 突然发现一篇搜索的题目都有写.昨天发现道bfs题目,HDU上AC, ZOJ上WA.不得不说HDU上的数据之水.. 今天早起刷题有了思路,并用队列和单调队列都写了一遍,0MS飘过~~ ~~~~ 题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=1242 http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=649 ~~~~ 首先有坑的地方是friends,对嘛,朋友有很多,ang